apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  name: wheel-match-tag
spec:
  description: >-
    Builds a src distribution and a binary wheel package from a source directory
  workspaces:
  - name: dist
    description: A workspace where distribution artifacts will be written
  params:
  - name: git-tag
    description: Git tag that tells expected version of module.
    type: string
  results:
  - name: version-tag-exist
    description: true tag starts with v, otherwise false.
  steps:
  - name: build
    image: "docker.io/library/python:3.10-slim-bullseye"
    workingDir: $(workspaces.dist.path)
    script: |
      #!/usr/bin/env python3

      from os import listdir
      from os.path import isfile, join
      import sys

      dir = "$(workspaces.dist.path)"
      gitTagVersion = "$(params.git-tag)".lstrip("vV.")

      if "$(params.git-tag)" == gitTagVersion:
        with open('$(results.version-tag-exist.path)', 'w') as f:
          f.write('false')
        sys.exit(0)
      else:
        with open('$(results.version-tag-exist.path)', 'w') as f:
          f.write('true')



      wheelFiles = [f for f in listdir(dir) if f.endswith(".whl") and isfile(join(dir, f))]
      if len(wheelFiles) != 1:
        print(f"Expected to find one Wheel file, found {len(wheelFiles)}.")
        sys.exit(2)

      wheelVersion = wheelFiles[0].split("-")[1]

      if wheelVersion != gitTagVersion:
        print(f"Wheel version {wheelVersion} do not match git tag version {gitTagVersion}.")
        sys.exit(1)
